package polyglot.ext.ibex.lr;

class ReduceEdge extends SREdge {
    GLRRule reduction;

    ReduceEdge(SRNode source, SRNode target, GLRRule reduction) {
        super(source, target, null);
        this.reduction = reduction;
    }

    public int hashCode() {
        return target.hashCode() + reduction.hashCode();
    }

    public boolean equals(Object o) {
        if (o instanceof ReduceEdge) {
            ReduceEdge e = (ReduceEdge) o;
            return target.equals(e.target) && reduction.equals(e.reduction);
        }
        return false;
    }

    public String toString() {
        return "reduce " + super.toString() + " with " + reduction;
    }
}
