package polyglot.ext.ibex.types;

import polyglot.types.*;
import polyglot.util.Position;
import java.util.List;

public interface IbexTypeSystem extends TypeSystem {
    Nonterminal nonterminal(Position pos, ParserType container, Flags flags, Type type, String name, List choices, boolean isStart);
    RhsCase rhsCase(Position pos, List elements, List tags);
    RhsMerge rhsMerge(Position pos, RhsCase rhs1, RhsCase rhs2);
    Terminal terminal(Position pos, ParserType container, Flags flags, Type type, String name);
    Symbol findSymbol(ParserType container, String name) throws SemanticException;
    ClassType runtimeMergeableType();
    ClassType runtimeParserType();
    ClassType runtimeParserImplType();
    ClassType runtimeGLRParserType();
    ClassType runtimeTerminalType();
}
