package polyglot.ext.op;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.Translator;
import polyglot.ext.jl.ast.Cast_c;
import java.util.*;

public class OPCast extends Cast_c {  

  public OPCast(Position pos, TypeNode castType, Expr expr) 
  {
    super(pos, castType, expr);
  }

    private static final String WRAPPER_PACKAGE = "polyglot.ext.op.runtime";
    private static Map wrapper = null;
    private static Map getter = null;

    public static String getter(Type t) {
        if (getter == null) {
            TypeSystem ts = t.typeSystem();
            getter = new HashMap();
            getter.put(ts.Boolean(), "booleanValue");
            getter.put(ts.Char(), "charValue");
            getter.put(ts.Short(), "shortValue");
            getter.put(ts.Int(), "intValue");
            getter.put(ts.Long(), "longValue");
            getter.put(ts.Float(), "floatValue");
            getter.put(ts.Double(), "doubleValue");
        }
        return (String) getter.get(t);
    }

    public static String wrapper(Type t) {
        if (wrapper == null) {
            TypeSystem ts = t.typeSystem();
            wrapper = new HashMap();
            wrapper.put(ts.Boolean(), "Boolean");
            wrapper.put(ts.Char(), "Character");
            wrapper.put(ts.Short(), "Short");
            wrapper.put(ts.Int(), "Integer");
            wrapper.put(ts.Long(), "Long");
            wrapper.put(ts.Float(), "Float");
            wrapper.put(ts.Double(), "Double");
        }
        return WRAPPER_PACKAGE + "." + (String) wrapper.get(t);
    }

    public void translate(CodeWriter w, Translator tr) {
        Type rtype = expr.type();
        Type ltype = castType.type();
        Context c = tr.context();
        TypeSystem ts = c.typeSystem();

        if (ltype.isPrimitive() && rtype.equals(ts.Object())) {
            w.write("((" + wrapper(ltype) + ")");
            printSubExpr(expr, w, tr);
            w.write(")." + getter(ltype) + "()");
        }
        else if (ltype.equals(ts.Object()) && rtype.isPrimitive()) {
            w.write("(new " + wrapper(rtype) + "(");
            printSubExpr(expr, w, tr);
            w.write("))");
        }
        else {
            super.del().translate(w, tr);
        }
    }
}
