/********************************************
 * The old PolyJAssign_c was divided into 
 * 3 classes (similar to what JL did):
 * PolyJLocalAssign_c, 
 * PolyJFieldAssign_c,
 * PolyJArrayAccessAssign_c; 
 * only difference is the tranlate function;
 ********************************/


package polyglot.ext.polyj.ast;

import polyglot.ext.polyj.extension.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.util.*;
import polyglot.ext.polyj.visit.*;

import polyglot.ext.jl.ast.*;

import polyglot.ast.*;
import polyglot.util.*;
import polyglot.types.*;
import polyglot.types.Package;
import polyglot.visit.*;

import java.util.*;

public class PolyJArrayAccessAssign_c extends ArrayAccessAssign_c implements PolyJAssign
{
	 public PolyJArrayAccessAssign_c(Position pos, ArrayAccess left, Operator op, Expr right) {
	    super(pos, left, op, right);
	  }
	 
	 public void translate(CodeWriter w, Translator tr) {
	     if (op == ASSIGN) {
		    PolyJExt leftDel = (PolyJExt) left.ext();
		    //HACK: this is *not* the right way to do this!  This uses
		    // a destructive update, rather than functional.  It really
		    // should be done with a visitor pass that replaces the
		    // left node.
		    this.left = (Expr) left.ext(leftDel.setLValue());
		}
	
		translateArray(w, tr);
	 }  
	 
    protected void translateArray(CodeWriter w, Translator tr) {
        Context c = tr.context();
        PolyJTypeSystem ts = (PolyJTypeSystem) c.typeSystem();
        TranslationTable tt = ts.translationTable();
        boolean isValueIgnored = ((PolyJExt)this.ext()).isValueIgnored();
	PolyJTranslator pjtr = (PolyJTranslator) tr;
	    
        PolyJArrayAccess arrayExpr = (PolyJArrayAccess) left;
        ArrayType arrayType = (ArrayType) arrayExpr.array().type();
        if (arrayType.base() instanceof ParamType) {
            ParamType elementType = (ParamType)arrayType.base();

            w.begin(0);
            if (!isValueIgnored) {
                w.write( "((" + elementType.name() + ")" );
            }

            ClassType scopedClass = c.currentClass();

            ArrayAccessBinding arrayBinding
                = ts.ArrayAccessBinding(elementType, scopedClass);

            if (arrayBinding == null) {
                throw new InternalCompilerError(
                    "Couldn't get array binding for \"" + arrayExpr + "\"");
            }

            w.allowBreak(2, "");
            w.write("((" 
	        + PolyJTranslator.adapterInterfaceFullName(scopedClass) 
		+ ")" + pjtr.whereObjExpr() + ")."
                + arrayBinding.set() + "(");

            w.begin(0);
            w.allowBreak(0);
            arrayExpr.array().del().translate(w, tr);
            w.write(",");
            w.allowBreak(0);
            arrayExpr.index().del().translate(w, tr);
            w.write(",");
            w.allowBreak(0);
            this.printSubExpr(right, w, tr);

            w.write( " )" );
            if (!isValueIgnored) {
                w.write( ")" );  //close the cast
            }

            w.end();
            w.end();
        } else {
            translateNormal(w, tr);
        }
    }

     protected void translateNormal(CodeWriter w, Translator tr) {
        super.translate(w, tr);
    }
    
}
	 
