/********************************************
 * The old PolyJAssign_c was divided into 
 * 3 classes (similar to what JL did):
 * PolyJLocalAssign_c, 
 * PolyJFieldAssign_c,
 * PolyJArrayAccessAssign_c; 
 * only difference is the tranlate function;
 ********************************/


package polyglot.ext.polyj.ast;

import polyglot.ext.polyj.extension.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.util.*;
import polyglot.ext.polyj.visit.*;

import polyglot.ext.jl.ast.*;

import polyglot.ast.*;
import polyglot.util.*;
import polyglot.types.*;
import polyglot.types.Package;
import polyglot.visit.*;

import java.util.*;

public class PolyJLocalAssign_c extends LocalAssign_c implements PolyJAssign
{
	
	public PolyJLocalAssign_c (Position pos, Local left, Operator op, Expr right)
	{
		super(pos, left, op, right);
	}
	
	public void translate(CodeWriter w, Translator tr)
	{
		 if (op == ASSIGN) {
			 PolyJExt leftDel = (PolyJExt) left.ext();
			 //HACK: this is *not* the right way to do this!  This uses
			 // a destructive update, rather than functional.  It really
			 // should be done with a visitor pass that replaces the
			 // left node.
			 this.left = (Expr) left.ext(leftDel.setLValue());
		 }

		 super.translate(w,tr);
	}
}
	
