package polyglot.ext.pure.extension;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;

import polyglot.ext.jl.ast.*;

import polyglot.ext.pure.types.*;
import polyglot.ext.pure.ast.*;

import java.util.*;

/** The Pure extension of the <code>Call</code> node. 
 * 
 *  @see polyglot.ext.jl.ast.Call_c
 */
public class PureCallExt extends JL_c
{
    public PureCallExt() { }

    public Node typeCheck(TypeChecker tc) throws SemanticException {
        Call n = (Call) super.typeCheck(tc);

        PureTypeSystem ts = (PureTypeSystem) tc.typeSystem();
        CodeInstance ci = tc.context().currentCode();

        MethodInstance mi = n.methodInstance();

        if (ci.flags().contains(ts.Pure()) &&
            ! mi.flags().contains(ts.Pure())) {

            throw new SemanticException("Cannot call non-pure method from " +
                                        ci + ".");
        }

        return n;
    }
}
